/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.24 by cnh, Wed Oct 29 13:42:10 2003 UTC revision 1.72 by edhill, Fri Mar 12 15:50:06 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 72  find_possible_configs()  { Line 77  find_possible_configs()  {
77    
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81        tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
84        PLATFORM=$tmp3
85      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
86      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
87            
88      echo "test" > test      echo "test" > test
89      ln -s ./test link      ln -s ./test link
# Line 103  find_possible_configs()  { Line 101  find_possible_configs()  {
101          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
102      fi      fi
103    
104        #  The "original" makedepend is part of the Imake system that is
105        #  most often distributed with XFree86 or with an XFree86 source
106        #  package.  As a result, many machines (eg. generic Linux) do not
107        #  have a system-default "makedepend" available.  For those
108        #  systems, we have two fall-back options:
109        #
110        #    1) a makedepend implementation shipped with the cyrus-imapd
111        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
112        #
113        #    2) a known-buggy xmakedpend shell script
114        #
115        #  So the choices are, in order:
116        #
117        #    1) use the user-specified program
118        #    2) use a system-wide default
119        #    3) locally build and use the cyrus implementation
120        #    4) fall back to the buggy local xmakedpend script
121        #
122        if test "x${MAKEDEPEND}" = x ; then
123          which makedepend > /dev/null 2>&1
124          RETVAL=$?
125          if test ! "x${RETVAL}" = x0 ; then
126             echo "    a system-default makedepend was not found."
127    
128             #  Try to build the cyrus impl
129             rm -f ./genmake_cy_md
130             (
131                 cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
132                     &&  ./configure > /dev/null 2>&1  \
133                     &&  make > /dev/null 2>&1  \
134                     &&  ./makedepend ifparser.c > /dev/null 2>&1  \
135                     &&  echo "true"
136             ) > ./genmake_cy_md
137             grep true ./genmake_cy_md > /dev/null 2>&1
138             RETVAL=$?
139             if test "x$RETVAL" = x0 ; then
140                 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
141             else
142                 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
143             fi
144             rm -f ./genmake_cy_md
145          fi
146        fi
147    
148      # look for possible fortran compilers      # look for possible fortran compilers
149      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
150      p_FC=      p_FC=
# Line 138  EOF Line 180  EOF
180          echo "   "$p_FC          echo "   "$p_FC
181          if test "x$FC" = x ; then          if test "x$FC" = x ; then
182              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
183                echo "  Setting FORTRAN compiler to: "$FC
184          fi          fi
185      fi      fi
186    
187      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
188          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
189          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
190              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
191              echo "  The options file:  $p_OF"          fi
192              echo "    appears to match so we'll use it."      fi
193              break  #    echo "  The options file:  $p_OF"
194          fi  #    echo "    appears to match so we'll use it."
195      done  #   for i in $p_FC ; do
196    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
197    #if test -r $p_OF ; then
198    #    OPTFILE=$p_OF
199    #    echo "  The options file:  $p_OF"
200    #    echo "    appears to match so we'll use it."
201    #    break
202    #fi
203    #   done
204      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
205          cat 1>&2 <<EOF          cat 1>&2 <<EOF
206    
# Line 205  get_pdepend_list()  { Line 256  get_pdepend_list()  {
256      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
257          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
258          > ./.pd_tmp          > ./.pd_tmp
259      source ./.pd_tmp      . ./.pd_tmp
260      rm -f ./.pd_tmp      rm -f ./.pd_tmp
261    
262      echo -n "PNAME = "${}      printf "PNAME = "${}
263  }  }
264    
265    
266  #  Explain usage  #  Explain usage
267  usage()  {  usage()  {
268      echo  cat <<EOF
269      echo "Usage: "$0" [OPTIONS]"  
270      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
271      echo    where [OPTIONS] can be:
272      echo "    -help | --help | -h | --h"  
273      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
274      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
275      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
276      echo "    -pdepend NAME | --pdepend NAME"      -nooptfile | --nooptfile
277      echo "      -pdepend=NAME | --pdepend=NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
278      echo "    -pdefault NAME | --pdefault NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
279      echo "      -pdefault=NAME | --pdefault=NAME"            Use "NAME" as the optfile.  By default, an attempt will be
280      echo "    -make NAME | -m NAME"            made to find an appropriate "standard" optfile in the
281      echo "      --make=NAME | -m=NAME"            tools/build_options/ directory.
282      echo "    -makefile NAME | -mf NAME"  
283      echo "      --makefile=NAME | -mf=NAME"      -pdepend NAME | --pdepend NAME
284      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"        -pdepend=NAME | --pdepend=NAME
285      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            Get package dependency information from "NAME".
286      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"  
287      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"      -pdefault NAME | --pdefault NAME
288      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"        -pdefault=NAME | --pdefault=NAME
289      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"            Get the default package list from "NAME".
290      echo "    -disable NAME | --disable NAME"  
291      echo "      -disable=NAME | --disable=NAME"      -make NAME | -m NAME
292      echo "    -enable NAME | --enable NAME"        --make=NAME | -m=NAME
293      echo "      -enable=NAME | --enable=NAME"            Use "NAME" for the MAKE program. The default is "make" but
294      echo "    -standarddirs NAME | --standarddirs NAME"            many platforms, "gmake" is the preferred choice.
295      echo "      -standarddirs=NAME | --standarddirs=NAME"  
296      echo "    -noopt NAME | --noopt NAME"      -makefile NAME | -mf NAME
297      echo "      -noopt=NAME | --noopt=NAME"        --makefile=NAME | -mf=NAME
298  #    echo "    -cpp NAME | --cpp NAME"            Call the makefile "NAME".  The default is "Makefile".
299  #    echo "      -cpp=NAME | --cpp=NAME"  
300      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"      -makedepend NAME | -md NAME
301      echo "      -fc=NAME | --fc=NAME"        --makedepend=NAME | -md=NAME
302      echo "    -[no]ieee | --[no]ieee"            Use "NAME" for the MAKEDEPEND program.
303      echo "    -[no]mpi | --[no]mpi"  
304      echo "    -[no]jam | --[no]jam"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
305      echo        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
306      echo "  and NAME is a string such as:"            Specify the location of the MITgcm ROOTDIR as "NAME".
307      echo            By default, genamke will try to find the location by
308      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"            looking in parent directories (up to the 5th parent).
309      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"  
310      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"      -mods NAME | --mods NAME | -mo NAME | --mo NAME
311      echo        -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
312      echo "  which, depending upon your shell, may need to be single-quoted"            Here, "NAME" specifies a list of directories that are
313      echo "  if it contains spaces, dashes, or other special characters."            used for additional source code.  Files found in the
314              "mods list" are given preference over files of the same
315              name found elsewhere.
316    
317        -disable NAME | --disable NAME
318          -disable=NAME | --disable=NAME
319              Here "NAME" specifies a list of packages that we don't
320              want to use.  If this violates package dependencies,
321              genamke will exit with an error message.
322    
323        -enable NAME | --enable NAME
324          -enable=NAME | --enable=NAME
325              Here "NAME" specifies a list of packages that we wish
326              to specifically enable.  If this violates package
327              dependencies, genamke will exit with an error message.
328    
329        -standarddirs NAME | --standarddirs NAME
330          -standarddirs=NAME | --standarddirs=NAME
331              Here, "NAME" specifies a list of directories to be
332              used as the "standard" code.
333    
334        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
335          -fc=NAME | --fc=NAME
336              Use "NAME" as the fortran compiler.  By default, genmake
337              will search for a working compiler by trying a list of
338              "usual suspects" such as g77, f77, etc.
339    
340        -[no]ieee | --[no]ieee
341              Do or don't use IEEE numerics.  Note that this option
342              *only* works if it is supported by the OPTFILE that
343              is being used.
344    
345        -mpi | --mpi
346              Include MPI header files and link to MPI libraries
347        -mpi=PATH | --mpi=PATH
348              Include MPI header files and link to MPI libraries using MPI_ROOT
349              set to PATH. i.e. Include files from $PATH/include, link to libraries
350              from $PATH/lib and use binaries from $PATH/bin.
351    
352        -bash NAME
353              Explicitly specify the Bourne or BASH shell to use
354    
355      While it is most often a single word, the "NAME" variables specified
356      above can in many cases be a space-delimited string such as:
357    
358        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
359        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
360        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
361    
362      which, depending upon your shell, may need to be single-quoted.
363    
364      For more detailed genmake documentation, please see:
365    
366        http://mitgcm.org/devel_HOWTO/
367    
368    EOF
369    
370      exit 1      exit 1
371  }  }
372    
373  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
374  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
375  #eh3 set CPP        = ( '/lib/cpp -P' )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
376  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      
377  #eh3 set KPP        = (  )      cat > genmake_test.c <<EOF
378  #eh3 set FC         = ( 'f77' )  void tcall( char * string ) { tsub( string ); }
379  #eh3 set LINK       = $FC  EOF
380  #eh3 set MAKEDEPEND = ( 'makedepend' )      $MAKE genmake_test.o >> genmake_warnings 2>&1
381  #eh3 set INCLUDES   = ( -I. )      RETVAL=$?
382  #eh3 set FFLAGS     = (  )      if test "x$RETVAL" != x0 ; then
383  #eh3 set FOPTIM     = (  )          FC_NAMEMANGLE=$default_nm
384  #eh3 set CFLAGS     = (  )          cat <<EOF>> genmake_errors
385  #eh3 set KFLAGS1    = (  )  
386  #eh3 set KFLAGS2    = (  )  WARNING: C test compile fails
387  #eh3 set LIBS       = (  )  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
388  #eh3 set KPPFILES   = (  )  WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
389  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )  EOF
390  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          return 1
391        fi
392        c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
393        RETVAL=$?
394        if test "x$RETVAL" != x0 ; then
395            FC_NAMEMANGLE=$default_nm
396            cat <<EOF>> genmake_warnings
397    
398    WARNING: The "nm" command failed.
399    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
400    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
401    EOF
402            return 1
403        fi
404        cat > genmake_tcomp.f <<EOF
405          subroutine tcall( string )
406          character*(*) string
407          call tsub( string )
408          end
409    EOF
410        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
411        RETVAL=$?
412        if test "x$RETVAL" != x0 ; then
413            FC_NAMEMANGLE=$default_nm
414            cat <<EOF>> genmake_warnings
415    
416    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
417    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
418    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
419    EOF
420            return 1
421        fi
422        f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
423        RETVAL=$?
424        if test "x$RETVAL" != x0 ; then
425            FC_NAMEMANGLE=$default_nm
426            cat <<EOF>> genmake_warnings
427    
428    WARNING: The "nm" command failed.
429    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
430    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
431    EOF
432            return 1
433        fi
434    
435        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
436        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
437        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
438        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
439    
440        nmangle="X"
441        if test "x$c_a" != "x$f_a" ; then
442            comm="echo x$f_a | sed -e 's|x$c_a||'"
443            a=`eval $comm`
444            nmangle="$a ## $nmangle"
445        fi
446        if test "x$c_b" != "x$f_b" ; then
447            comm="echo x$f_b | sed -e 's|x$c_b||'"
448            b=`eval $comm`
449            nmangle="$nmangle ## $b"
450        fi
451    
452        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
453    
454        #  cleanup the testing files
455        rm -f genmake_tcomp.* genmake_test.*
456    }
457    
458    
459    check_HAVE_CLOC()  {
460        get_fortran_c_namemangling
461        cat <<EOF > genmake_tc_1.c
462    $FC_NAMEMANGLE
463    #include <stdio.h>
464    #include <stdlib.h>
465    #include <unistd.h>
466    #include <assert.h>
467    #include <sys/time.h>
468    void FC_NAMEMANGLE(cloc) ( double *curtim )
469    {
470     struct timeval tv1;
471     gettimeofday(&tv1 , (void *)NULL );
472     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
473     *curtim = *curtim/1.E6;
474    }
475    EOF
476        make genmake_tc_1.o >> genmake_tc.log 2>&1
477        RET_C=$?
478        cat <<EOF > genmake_tc_2.f
479          program hello
480          Real*8 wtime
481          external cloc
482          call cloc(wtime)
483          print *," HELLO WORLD", wtime
484          end program hello
485    EOF
486        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
487        RET_F=$?
488        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
489        RETVAL=$?
490        if test "x$RETVAL" = x0 ; then
491            HAVE_CLOC=t
492            DEFINES="$DEFINES -DHAVE_CLOC"
493        fi
494        rm -f genmake_tc*
495    }
496    
497    
498    check_netcdf_libs()  {
499        cat <<EOF > genmake_tnc.F
500          program fgennc
501    #include "netcdf.inc"
502          integer iret, ncid, xid
503          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
504          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
505          iret = nf_def_dim(ncid, 'X', 11, xid)
506          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
507          iret = nf_close(ncid)
508          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
509          end
510    EOF
511        $CPP genmake_tnc.F > genmake_tnc.f  \
512            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
513        RET_COMPILE=$?
514        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
515        RETVAL=$?
516        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
517            HAVE_NETCDF=t
518        else
519            # try again with "-lnetcdf" added to the libs
520            $CPP genmake_tnc.F > genmake_tnc.f  \
521                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
522                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
523            RET_COMPILE=$?
524            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
525            RETVAL=$?
526            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
527                LIBS="$LIBS -lnetcdf"
528                HAVE_NETCDF=t
529            else
530                cat genmake_tnc.log >> genmake_warnings
531            fi
532        fi
533        rm -f genmake_tnc*
534    }
535    
536    
537    
538    ###############################################################################
539    #   Sequential part of script starts here
540    ###############################################################################
541    
542  #  Set defaults here  #  Set defaults here
543  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 290  LN= Line 547  LN=
547  S64=  S64=
548  KPP=  KPP=
549  FC=  FC=
550    CPP=
551  LINK=  LINK=
552  DEFINES="-DWORDLENGTH=4"  DEFINES=
553  PACKAGES=  PACKAGES=
554  ENABLE=  ENABLE=
555  DISABLE=  DISABLE=
# Line 307  FOPTIM= Line 565  FOPTIM=
565  CFLAGS=  CFLAGS=
566  KFLAGS1=  KFLAGS1=
567  KFLAGS2=  KFLAGS2=
568    #LDADD=
569  LIBS=  LIBS=
570  KPPFILES=  KPPFILES=
571  NOOPTFILES=  NOOPTFILES=
572  NOOPTFLAGS=  NOOPTFLAGS=
573    MPI=
574    MPIPATH=
575    
576    # DEFINES checked by test compilation
577    HAVE_SYSTEM=
578    HAVE_FDATE=
579    FC_NAMEMANGLE=
580    HAVE_CLOC=
581    HAVE_NETCDF=
582    
583  MODS=  MODS=
584  TOOLSDIR=  TOOLSDIR=
585  SOURCEDIRS=  SOURCEDIRS=
586  INCLUDEDIRS=  INCLUDEDIRS=
587  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
588    
589    BASH=
590  PWD=`pwd`  PWD=`pwd`
591  MAKE=make  MAKE=make
592  AWK=awk  AWK=awk
# Line 349  TAMC_EXTRA= Line 618  TAMC_EXTRA=
618    
619    
620  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
621  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
622  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
623    
624  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
625  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
626  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
627  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
628  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
629    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"
630    
631  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
632  gm_s7="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
633  gm_s8="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"  gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
634  gm_s9="TAF_EXTRA TAMC_EXTRA"  gm_s12="TAF_EXTRA TAMC_EXTRA"
635    
636  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7 $gm_s8 $gm_s9"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
637    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
638    
639    cat <<EOF
640    
641    GENMAKE :
642    
643    A program for GENerating MAKEfiles for the MITgcm project.  For a
644    quick list of options, use "genmake -h" or for more detail see:
645    
646      http://mitgcm.org/devel_HOWTO/
647    
648    EOF
649    
 echo  
650  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
651  gm_local="genmake_local"  gm_local="genmake_local"
652  for i in . $MODS ; do  for i in . $MODS ; do
653      if test -r $i/$gm_local ; then      if test -r $i/$gm_local ; then
654          source $i/$gm_local          . $i/$gm_local
655          break          break
656      fi      fi
657  done  done
658  echo -n "  getting local config information:  "  printf "  getting local config information:  "
659  if test -e $gm_local ; then  if test -e $gm_local ; then
660      echo "using $gm_local"      echo "using $gm_local"
661      source $gm_local      . $gm_local
662      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
663      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
664  else  else
# Line 420  for ac_option ; do Line 700  for ac_option ; do
700          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
701              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
702                    
703          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
704              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
705          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
706              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 440  for ac_option ; do Line 720  for ac_option ; do
720          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
721              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
722                    
723            -bash | --bash)
724                ac_prev=BASH ;;
725            -bash=* | --bash=*)
726                BASH=$ac_optarg ;;
727            
728            -makedepend | --makedepend | -md | --md)
729                ac_prev=MAKEDEPEND ;;
730            -makedepend=* | --makedepend=* | -md=* | --md=*)
731                MAKEDEPEND=$ac_optarg ;;
732            
733          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
734              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
735          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
736              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
737                    
738          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
739              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
740          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
741              PLATFORM=$ac_optarg ;;              echo
742                usage
743                ;;
744                    
745          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
746              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 475  for ac_option ; do Line 767  for ac_option ; do
767          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
768              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
769    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
770  #           -cpp | --cpp)  #           -cpp | --cpp)
771  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
772  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 494  for ac_option ; do Line 781  for ac_option ; do
781              IEEE=true ;;              IEEE=true ;;
782          -noieee | --noieee)          -noieee | --noieee)
783              IEEE= ;;              IEEE= ;;
784            
785          -mpi | --mpi)          -mpi | --mpi)
786              MPI=true ;;              MPI=true ;;
787          -nompi | --nompi)          -mpi=* | --mpi=*)
788              MPI= ;;              MPIPATH=$ac_optarg
789                MPI=true ;;
790                    
791          -jam | --jam)  #       -jam | --jam)
792              JAM=1 ;;  #           JAM=1 ;;
793          -nojam | --nojam)  #       -nojam | --nojam)
794              JAM=0 ;;  #           JAM=0 ;;
795                    
796          -ds | --ds)          -ds | --ds)
797              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 551  if test "x${ROOTDIR}" = x ; then Line 839  if test "x${ROOTDIR}" = x ; then
839          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
840              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
841                  ROOTDIR=$d                  ROOTDIR=$d
842                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
843                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
844                  break                  break
845              fi              fi
# Line 582  fi Line 870  fi
870  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
871      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
872          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
873          source "$OPTFILE"          . "$OPTFILE"
874          RETVAL=$?          RETVAL=$?
875          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
876              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
877              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
878              exit 1              exit 1
879          fi          fi
# Line 609  fi Line 897  fi
897  if test "x${AD_OPTFILE}" != xNONE ; then  if test "x${AD_OPTFILE}" != xNONE ; then
898      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
899          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
900          source "$AD_OPTFILE"          . "$AD_OPTFILE"
901          RETVAL=$?          RETVAL=$?
902          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
903              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
904              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
905              exit 1              exit 1
906          fi          fi
# Line 625  if test "x${AD_OPTFILE}" != xNONE ; then Line 913  if test "x${AD_OPTFILE}" != xNONE ; then
913      fi      fi
914  fi  fi
915    
916  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
917  #  and abort!  #  either set defaults or complain and abort!
918    if test ! "x$BASH" = x ; then
919        # add a trailing space so that it works within the Makefile syntax (see below)
920        BASH="$BASH "
921    fi
922  if test "x$FC" = x ; then  if test "x$FC" = x ; then
923      cat <<EOF 1>&2      cat <<EOF 1>&2
924    
# Line 640  fi Line 932  fi
932  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
933      LINK=$FC      LINK=$FC
934  fi  fi
935    if test "x$MAKE" = x ; then
936        MAKE="make"
937    fi
938  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
939      CPP="cpp"      CPP=cpp
940  fi  fi
941    #EH3 === UGLY ===
942    #  The following an ugly little hack to check for $CPP in /lib/ and it
943    #  should eventually be replaced with a more general function that
944    #  searches a combo of the user's path and a list of "usual suspects"
945    #  to find the correct location for binaries such as $CPP.
946    for i in " " "/lib/" ; do
947        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
948    done
949    #EH3 === UGLY ===
950  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
951  RETVAL=$?  RETVAL=$?
952  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 652  Error: C pre-processor "$CPP" failed the Line 956  Error: C pre-processor "$CPP" failed the
956    
957    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
958    2) the "./genmake_local" file    2) the "./genmake_local" file
959      3) with the CPP environment variable
960    
961  EOF  EOF
962      exit 1      exit 1
# Line 661  fi Line 966  fi
966  if test "x$MAKEDEPEND" = x ; then  if test "x$MAKEDEPEND" = x ; then
967      MAKEDEPEND=makedepend      MAKEDEPEND=makedepend
968  fi  fi
969    if test "x$LN" = x ; then
970        LN="ln -s"
971    fi
972    echo "test" > genmake_test_ln
973    $LN genmake_test_ln genmake_tlink
974    RETVAL=$?
975    if test "x$RETVAL" != x0 ; then
976        cat <<EOF 1>&2
977    
978    Error: The command "ln -s" failed -- please specify a working soft-link
979      command in the optfile.
980    
981    EOF
982        exit 1
983    fi
984    rm -f genmake_test_ln genmake_tlink
985    
986    if test ! "x$MPI" = x ; then
987          echo "  Turning on MPI cpp macros"
988          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
989    fi
990    
991    printf "\n===  Checking system libraries  ===\n"
992    printf "  Do we have the system() command using $FC...  "
993    cat > genmake_tcomp.f <<EOF
994          program hello
995          call system('echo hi')
996          end
997    EOF
998    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
999    RETVAL=$?
1000    if test "x$RETVAL" = x0 ; then
1001        HAVE_SYSTEM=t
1002        DEFINES="$DEFINES -DHAVE_SYSTEM"
1003        echo "yes"
1004    else
1005        HAVE_SYSTEM=
1006        echo "no"
1007    fi
1008    rm -f genmake_tcomp*
1009    
1010    printf "  Do we have the fdate() command using $FC...  "
1011    cat > genmake_tcomp.f <<EOF
1012          program hello
1013          CHARACTER(128) string
1014          string = ' '
1015          call fdate( string )
1016          print *, string
1017          end
1018    EOF
1019    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1020    RETVAL=$?
1021    if test "x$RETVAL" = x0 ; then
1022        HAVE_FDATE=t
1023        DEFINES="$DEFINES -DHAVE_FDATE"
1024        echo "yes"
1025    else
1026        HAVE_FDATE=
1027        echo "no"
1028    fi
1029    rm -f genmake_tcomp*
1030    
1031    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1032    check_HAVE_CLOC
1033    if test "x$HAVE_CLOC" != x ; then
1034        echo "yes"
1035    else
1036        echo "no"
1037    fi
1038    rm -f genmake_t*
1039    
1040    printf "  Can we create NetCDF-enabled binaries...  "
1041    check_netcdf_libs
1042    if test "x$HAVE_NETCDF" != x ; then
1043        echo "yes"
1044    else
1045        echo "no"
1046    fi
1047    
1048    
1049  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1050  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1051  for d in $MODS ; do  for d in $MODS ; do
1052      if test ! -d $d ; then      if test ! -d $d ; then
1053          echo          echo
1054          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1055          exit 1          exit 1
1056      else      else
1057          echo -n " $d"          printf " $d"
1058          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1059          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1060      fi      fi
# Line 700  if test "x${TOOLSDIR}" = x ; then Line 1084  if test "x${TOOLSDIR}" = x ; then
1084      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1085  fi  fi
1086  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1087      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1088      exit 1      exit 1
1089  fi  fi
1090  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1091      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
1092  fi  fi
1093    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1094    
1095  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1096    
# Line 714  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 1099  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1099  #  they appear as regular source code  #  they appear as regular source code
1100  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1101      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
1102      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1103      RETVAL=$?      RETVAL=$?
1104      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
1105          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1106      else      else
1107          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1108          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1109          exit 1          exit 1
1110      fi      fi
1111  fi  fi
1112    
1113    #same for exch2
1114    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1115        echo "  Making source files in exch2 from  templates"
1116        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1117        RETVAL=$?
1118        if test "x${RETVAL}" = x0 ; then
1119            rm -f make_exch2.errors
1120        else
1121            echo "Error: problem encountered while building source files in exch2:"
1122            cat make_exch2.errors 1>&2
1123            exit 1
1124        fi
1125    fi
1126    
1127  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1128  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1129      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 751  if test ! "x${RETVAL}" = x0 ; then Line 1150  if test ! "x${RETVAL}" = x0 ; then
1150      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1151      exit 1      exit 1
1152  fi  fi
1153  source ./.pd_tmp  . ./.pd_tmp
1154  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1155    
1156  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1157  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1158  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1159  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1160  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1161      for i in "." $MODS ; do      for i in "." $MODS ; do
1162          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 770  if test "x${PDEFAULT}" = x ; then Line 1169  if test "x${PDEFAULT}" = x ; then
1169      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1170  fi  fi
1171  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1172      echo "default packages file disabled"      echo "    default packages file disabled"
1173  else  else
1174      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1175          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1176      else      else
1177          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1178          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1179          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1180          RETVAL=$?          RETVAL=$?
1181          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1182              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1183              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1184              exit 1              exit 1
1185          fi          fi
# Line 909  for i in $PACKAGES ; do Line 1307  for i in $PACKAGES ; do
1307      fi      fi
1308  done  done
1309    
1310  #  This is compatible with the old genmake.  The "DISABLE_*" flags  #  Build MNC templates and check for ability to build and use NetCDF
1311  #  need to be replaced by the "ALLOW_*" flags set below.  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1312  #  RETVAL=$?
1313  # echo -n "  Setting package-specific CPP flags:  "  if test "x$RETVAL" = x0 ; then
1314  # pkrm=( mom_fluxform mom_vecinv generic_advdiff )      ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1315  # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )      RETVAL=$?
1316  # echo -n "  "      if test "x${RETVAL}" = x0 ; then
1317  # i=0          rm -f make_mnc.errors
1318  # while test $i -lt "${#pkrm[@]}" ; do      else
1319  #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1          echo "Error: problem encountered while building source files in pkg/mnc:"
1320  #     RETVAL=$?          cat make_mnc.errors 1>&2
1321  #     if test "x$RETVAL" = x1 ; then          exit 1
1322  #       DEFINES="$DEFINES ${pkdef[$i]}"      fi
1323  #       echo -n " ${pkdef[$i]}"      if test "x$HAVE_NETCDF" != xt ; then
1324  #     fi          cat <<EOF
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
   
 # Create a list of #define and #undef to enable/disable packages  
 PACKAGES_DOT_H=PACKAGES_CONFIG.h  
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
1325    
1326  #ifndef PACKAGES_H  WARNING: the "mnc" package has been enabled but tests failed to
1327  #define PACKAGES_H    compile and/or execute NetCDF applications.  Please check that:
1328    
1329  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1330      2) the LIBS variable (within the 'optfile") specifies the correct
1331           NetCDF library to link against.
1332      
1333  EOF  EOF
1334        fi
1335    fi
1336    
1337    # Create a list of #define and #undef to enable/disable packages
1338    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1339  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1340  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1341  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1342  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1343  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1344  all_pack=  all_pack=
1345    DISABLED_PACKAGES=
1346  for n in $names ; do  for n in $names ; do
1347      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1348          has_pack="f"          has_pack="f"
# Line 959  for n in $names ; do Line 1354  for n in $names ; do
1354          done          done
1355          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1356              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1357              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
 #           DEFINES="$DEFINES -U$undef"  
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1358          fi          fi
1359      fi      fi
1360  done  done
1361  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1362  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1363      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1364      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1365  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1366    
1367  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1368      case $i in      case $i in
1369          aim_v23)          aim_v23)
1370              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1371              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1372              ;;              ;;
1373      esac      esac
1374  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1375    
1376  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1377    
1378  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1379  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1380  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1381      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1382  fi  fi
1383  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1384      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1385      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1386          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1387          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1388          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1389      else              exit 1
1390          SOURCEDIRS="$SOURCEDIRS $adr"          else
1391      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1392      adr="$ROOTDIR/$d/inc"          fi
1393      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1394          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1395          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1396          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1397      else              exit 1
1398          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1399      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1400  done          fi
1401        done
1402    fi
1403    
1404  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1405  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1406  CPP_OPTIONS=  CPP_OPTIONS=
1407    CPP_EEOPTIONS=
1408  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1409    names=`ls -1 "$ROOTDIR/pkg"`
1410  for i in $spaths ; do  for i in $spaths ; do
1411      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1412      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1413          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1414          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1415          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1416            for n in $names ; do
1417                test_for_package_in_cpp_options $CPP_OPTIONS $n
1418            done
1419        fi
1420        try="$i/CPP_EEOPTIONS.h"
1421        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1422            echo "    found CPP_EEOPTIONS=\"$try\""
1423            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1424    #**** not yet enabled ****
1425    #        test_for_mpi_in_cpp_eeoptions $try
1426    #**** not yet enabled ****
1427            CPP_EEOPTIONS="$try"
1428      fi      fi
1429  done  done
1430  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1431      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1432      exit 1      exit 1
1433  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1434    
1435  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1436  #  compiler.  #  compiler.
# Line 1078  for i in $SOURCEDIRS ; do Line 1445  for i in $SOURCEDIRS ; do
1445      done      done
1446  done  done
1447    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1448    
1449  echo  echo
1450  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1106  rm -rf .links.tmp Line 1462  rm -rf .links.tmp
1462  mkdir .links.tmp  mkdir .links.tmp
1463  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1464  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1465  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1466  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1467  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1468  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1469  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1470  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1471  for d in $alldirs ; do  for d in $alldirs ; do
1472      deplist=      deplist=
# Line 1119  for d in $alldirs ; do Line 1475  for d in $alldirs ; do
1475      for sf in $sfiles ; do      for sf in $sfiles ; do
1476          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1477              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1478                    case $d/$sf in
1479                      ./$PACKAGES_DOT_H)
1480                            ;;
1481                      ./AD_CONFIG.h)
1482                            ;;
1483                      ./FC_NAMEMANGLE.h)
1484                            ;;
1485                      *)
1486                            touch .links.tmp/$sf
1487                            deplist="$deplist $sf"
1488                            ;;
1489                    esac
1490                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1491                  case $extn in                  case $extn in
1492                      F)                      F)
1493                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1494                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1495                          ;;                          ;;
1496                      F90)                      F90)
1497                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1498                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1499                          ;;                          ;;
1500                      c)                      c)
1501                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1502                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1503                          ;;                          ;;
1504                      h)                      h)
1505                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1506                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1507                          ;;                          ;;
1508                      flow)                      flow)
1509                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1510                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1511                          ;;                          ;;
1512                  esac                  esac
1513              fi              fi
# Line 1179  EXE_FTL=$EXECUTABLE"_ftl" Line 1545  EXE_FTL=$EXECUTABLE"_ftl"
1545  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1546    
1547  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1548    #
1549    # OPTFILE="$OPTFILE"
1550  #  #
1551  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1552  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1212  EXE_AD      = ${EXE_AD} Line 1580  EXE_AD      = ${EXE_AD}
1580  EXE_FTL     = ${EXE_FTL}  EXE_FTL     = ${EXE_FTL}
1581  EXE_SVD     = ${EXE_SVD}  EXE_SVD     = ${EXE_SVD}
1582    
1583    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1584    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1585    
1586    # These files are created by Makefile
1587    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1588    
1589  EOF  EOF
1590    
1591  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1230  FC = ${FC} Line 1604  FC = ${FC}
1604  # Fortran compiler  # Fortran compiler
1605  F90C = ${F90C}  F90C = ${F90C}
1606  # Link editor  # Link editor
1607  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1608    
1609  # Defines for CPP  # Defines for CPP
1610  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1276  cat >>$MAKEFILE <<EOF Line 1650  cat >>$MAKEFILE <<EOF
1650  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1651    
1652  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1653  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1654            @echo Creating \$@ ...
1655          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1656  depend:  depend:
1657          @make links          @make links
1658          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1659          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1660            -rm -f makedepend.out
1661    
1662  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1663    
1664  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1665    
# Line 1292  output.txt: \$(EXECUTABLE) Line 1668  output.txt: \$(EXECUTABLE)
1668          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1669    
1670  clean:  clean:
1671          -cat AD_CONFIG.template > AD_CONFIG.h          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template
         -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}  
1672  Clean:  Clean:
1673          @make clean          @make clean
1674          @make cleanlinks          @make cleanlinks
1675          -rm -f Makefile.bak genmake_state genmake_*optfile make.log          -rm -f \$(SPECIAL_FILES)
1676            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1677  CLEAN:  CLEAN:
1678          @make Clean          @make Clean
1679          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1307  CLEAN: Line 1683  CLEAN:
1683    
1684  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1685  makefile:  makefile:
1686          ${0} $@          $THIS_SCRIPT $@
1687  cleanlinks:  cleanlinks:
1688          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1689    
1690    # Special targets ($SPECIAL_FILES) which are create by make
1691    ${PACKAGES_DOT_H}:
1692            @echo Creating \$@ ...
1693            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1694    AD_CONFIG.h:
1695            @echo Creating \$@ ...
1696            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1697    FC_NAMEMANGLE.h:
1698            @echo Creating \$@ ...
1699            echo "$FC_NAMEMANGLE" > \$@
1700    
1701  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1702  .F.f:  .F.f:
1703          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
# Line 1353  done Line 1740  done
1740    
1741  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
1742  echo >> $MAKEFILE  echo >> $MAKEFILE
1743  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
1744  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
1745  for i in $AD_FILES ; do  for i in $AD_FILES ; do
1746      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
1747      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
1748  done  done
1749  echo >> $MAKEFILE  echo >> $MAKEFILE
1750  rm -f ad_files  rm -f ad_files
# Line 1369  adall: ad_taf Line 1756  adall: ad_taf
1756  adtaf: ad_taf_output.f  adtaf: ad_taf_output.f
1757  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1758    
1759  ad_input_code.f: \$(SRCFILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1760            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1761          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1762            -rm -f ad_config.template
1763          @make \$(F77FILES)          @make \$(F77FILES)
1764          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1765          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1766    
1767  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
1768          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1769          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1770    
1771    adtafonly:
1772            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1773            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1774    
1775  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1776          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1777    
1778  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
1779          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1780          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1781    
1782  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
1783          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 1395  ftlall: ftl_taf Line 1788  ftlall: ftl_taf
1788  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.f
1789  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1790    
1791  ftl_input_code.f: \$(SRCFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1792            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1793          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1794            -rm -f ftl_config.template
1795          @make \$(F77FILES)          @make \$(F77FILES)
1796          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1797          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1798    
1799  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.f: ftl_input_code.f
1800          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1801          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1802    
1803    ftltafonly:
1804            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1805            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1806    
1807  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
1808          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1809    
1810  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.f: ftl_input_code.f
1811          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1812          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1813    
1814  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1815          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1816    
1817    
1818  # ... SVD ...  # ... SVD ...
1819  svd: svd_taf  svdtaf: ad_taf_output.f ftl_taf_output.f
1820  svd_taf_f: svd_taf_output.f  svdall: svd_taf
   
 svd_input_code.f: \$(SRCFILES)  
         cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h  
         @make \$(F77FILES)  
         @make \$(AD_FLOW_FILES)  
         cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f  
1821    
1822  svd_taf_output.f: svd_input_code.f  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
1823          \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
         cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f  
   
 svd_taf: svd_taf_output.o \$(OBJFILES)  
         \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)  
1824    
1825    
1826  #=========================================  #=========================================
# Line 1472  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1861  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1861    
1862  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1863    
1864  #  Write the "template" files for the adjoint builds  # Create special header files
1865  cat >AD_CONFIG.template <<EOF  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1866  C  WARNING: This file is automatically generated by genmake2 and  if test ! -f $PACKAGES_DOT_H ; then
1867  C    used by the Makefile rules.  Please DO NOT EDIT this file      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1868  C    unless you are CERTAIN that you know what you are doing.  else
1869        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
1870  #undef ALLOW_ADJOINT_RUN      RETVAL=$?
1871  #undef ALLOW_TANGENTLINEAR_RUN      if test "x$RETVAL" = x0 ; then
1872  #undef ALLOW_ECCO_OPTIMIZATION          rm -f $PACKAGES_DOT_H".tmp"
1873  EOF      else
1874  cat >ad_config.template <<EOF          mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1875  C  WARNING: This file is automatically generated by genmake2 and          mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1876  C    used by the Makefile rules.  Please DO NOT EDIT this file      fi
1877  C    unless you are CERTAIN that you know what you are doing.  fi
1878    if test ! -f AD_CONFIG.h ; then
1879  #define ALLOW_ADJOINT_RUN      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1880  #undef ALLOW_TANGENTLINEAR_RUN  fi
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >ftl_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #define ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >svd_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #undef ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cp AD_CONFIG.template AD_CONFIG.h  
1881    
1882    
1883  #  Write the "state" for future records  #  Write the "state" for future records
1884  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1885      echo -n "" > genmake_state      printf "" > genmake_state
1886      for i in $gm_state ; do      for i in $gm_state ; do
1887          t1="t2=\$$i"          t1="t2=\$$i"
1888          eval $t1          eval $t1

Legend:
Removed from v.1.24  
changed lines
  Added in v.1.72

  ViewVC Help
Powered by ViewVC 1.1.22